package de.unihannover.orderingExperimentAnalysis;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map.Entry;

import de.unihannover.orderingExperimentUi.DataLog;
import de.unihannover.orderingExperimentUi.Experiment;

public class ExtractDataFromDump {

    public static void main(String[] args) throws Exception {
        final byte[] content = Files.readAllBytes(Paths.get("formDataFromDump2.txt"));
        final String s = new String(content, StandardCharsets.UTF_8);
        final Map<String, String> splitQuery = splitQuery(s);
        printResult(splitQuery);
    }

    private static void printResult(Map<String, String> params) {
        int index = -1;
        final Experiment exp = new Experiment(1234567);
        for (final Entry<String, String> e : params.entrySet()) {
            if (exp.isVariableName(e.getKey())) {
                exp.setVariable(e.getKey(), new String[] {e.getValue()});
            } else if (e.getKey().equals("index")) {
                index = Integer.parseInt(e.getValue());
            } else if (e.getKey().equals("logContent")) {
                //ok, will be handled later
            } else {
                throw new RuntimeException("invalid param " + e.getKey());
            }
        }
        final String log = params.get("logContent");
        for (final String logLine : log.split("\n")) {
            DataLog.log(exp.getId(), "log from review;" + index + ";" + logLine);
        }
    }

    public static Map<String, String> splitQuery(String query) throws UnsupportedEncodingException {
        final Map<String, String> query_pairs = new LinkedHashMap<String, String>();
        final String[] pairs = query.split("&");
        for (final String pair : pairs) {
            final int idx = pair.indexOf("=");
            query_pairs.put(URLDecoder.decode(pair.substring(0, idx), "UTF-8"), URLDecoder.decode(pair.substring(idx + 1), "UTF-8"));
        }
        return query_pairs;
    }

}
