package de.unihannover.orderingExperimentAnalysis;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class ExtractNavigationTraces {

    public static void main(String[] args) throws Exception {
        try {
            print(AnalyzeExperimentLogs.getFiles());
//            print("../OrderingExperimentUI/experiment.1502467398468.log");
        } catch (final Exception e) {
            System.out.println();
            e.printStackTrace(System.out);
        }
    }

    private static void print(String... filenames) throws IOException {
        final LogRecords log = LogRecords.load(filenames);
        final Collection<SessionData> sessions = log.getSplitByParticipant();

        sessions.removeIf(SessionData::isJeditIncomplete);
        sessions.removeIf(SessionData::isDuplicateParticipation);

        try (PrintStream p = new PrintStream(new File("navigation.ps"))) {
            final List<NavigationTrace> traces = getTraces(sessions);

            p.println("%!PS-Adobe-3.0");
            p.println("%%Pages: " + traces.size());
            p.println("%%DocumentMedia:");
            traces.stream()
                .map(NavigationTrace::getPageWidth)
                .distinct()
                .forEach((Integer size) -> p.println("%%+ m" + size + " " + size + " 595 80 white ( )"));
            p.println("%%EndComments");
            p.println("%%BeginProlog");
            p.println("/showflip {gsave 1 -1 scale show grestore} bind def");
            p.println("/Helvetica 10 selectfont");
            p.println("%%EndProlog");

            int i = 0;
            for (final NavigationTrace t : traces) {
                i++;
                p.println("%%Page: " + i + " " + i);
                t.toPostscript(p);
                p.println("showpage\n");
            }
            p.println("%%EOF");
        }
    }

    private static List<NavigationTrace> getTraces(Collection<SessionData> sessions) {
        final List<NavigationTrace> ret = new ArrayList<>();
        for (final SessionData s : sessions) {
            for (int i = 0; i < 3; i++) {
                ret.add(s.extractNavigationTrace(i));
            }
        }
        return ret;
    }

}
