package de.unihannover.orderingExperimentAnalysis;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

public class FilterSvnLog {

    private static int count;

    public static void main(String[] args) throws IOException {
//        filter("jeditLog.txt", 7, 14);
        filter("jeditLog.txt", 2, 2);
    }

    private static void filter(String filename, int minJavaFileCount, int maxJavaFileCount) throws IOException {
        String revision = null;
        final StringBuilder message = new StringBuilder();
        final List<String> files = new ArrayList<>();
        boolean inMessage = false;
        for (final String line : Files.readAllLines(Paths.get(filename))) {
            if (line.startsWith("Revision:")) {
                if (revision != null) {
                    checkLogEntry(revision, message, files, minJavaFileCount, maxJavaFileCount);
                }
                revision = line;
                message.setLength(0);
                files.clear();
            } else if (line.startsWith("Message:")) {
                inMessage = true;
            } else if (line.startsWith("----")) {
                inMessage = false;
            } else if (inMessage) {
                message.append(line).append('\n');
            } else if (line.startsWith("Modified : ")
                    || line.startsWith("Added : ")
                    || line.startsWith("Deleted : ")) {
                files.add(line);
            }
        }
        if (revision != null) {
            checkLogEntry(revision, message, files, minJavaFileCount, maxJavaFileCount);
        }
    }

    private static void checkLogEntry(
                    String revision,
                    StringBuilder message,
                    List<String> files,
                    int minJavaFileCount,
                    int maxJavaFileCount) {

        final long javaFileCount = files.stream().filter((String x) -> x.endsWith(".java")).count();
        if (javaFileCount < minJavaFileCount || javaFileCount > maxJavaFileCount) {
            return;
        }

        System.out.println(String.format("%04d, %s, %02d, %02d, %s",
                        count++, revision, javaFileCount, files.size(), message.toString().trim().replace('\n', ' ')));
    }

}
