#R stuff
#x <- c(10.4, 5.6, 3.1, 6.4, 21.7)
#y <- c(x, 0, x)

generateExperimentSettings <- function(cnt) {
  myData <- data.frame(
    participantCount = sample(55:65, cnt, replace=T)
  )
  write.table(myData, file = "experiments.csv", row.names = FALSE, sep = ';', quote = T)
  return(myData)
}

generateParticipantData <- function(cnt) {
  myData <- data.frame(
    experienceSoftwareDev = sample(1:5, cnt, replace=T),
    currentProgrammingPractice = sample(2:5, cnt, replace=T, prob=c(.05,.15,.2,.6)),
    currentReviewPractice = sample(1:5, cnt, replace=T, prob=c(.3,.05,.05,.2,.4)),
    workingHours = sample(0:9, cnt, replace=T),
    hasExperience = sample(c(T, F), cnt, replace=T, prob=c(.01,.99)),
    screenHeight = sample(c(768, 1080, 1024), cnt, replace=T),
    workingMemorySpan = pmin(pmax(rnorm(cnt, 60, 15), 0), 80)
  )
  myData$experienceJava <- pmin(pmax(myData$experienceSoftwareDev + sample(-1:1, cnt, replace=T), 1), 5)
  write.table(myData, file = "participants.csv", row.names = FALSE, sep = ';')
}

exps <- generateExperimentSettings(1000)
generateParticipantData(sum(exps$participantCount))
